﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class EmptyEvent : CodeNode {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private EmptyEvent(bool deserializing) : base(deserializing) { }
    private EmptyEvent(EmptyEvent original, Cloner cloner)
      : base(original, cloner) {
    }

    public EmptyEvent()
      : base("EmptyEvent", "This is a placeholder for an empty event.") {
      this.Prefix = "";
      this.Suffix = "";
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new EmptyEvent(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return "";
    }
  }
}
